﻿
EnableExplicit

;******************
;- Constants
;******************

CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Linux
      #NEWLINE$ = #LF$
    CompilerCase #PB_OS_MacOS
      #NEWLINE$ = #CR$
    CompilerDefault
      #NEWLINE$ = #CRLF$
CompilerEndSelect

#DEBUGOFFSET = 2

;******************
;- Global functions
;******************

Procedure multiLineDebug(debugString.s)
    Define amount.i
    amount = CountString(debugString, #NEWLINE$)
    
    Define c.i
    For c = 1 To amount+1
        Debug StringField(debugString, c, #NEWLINE$)
    Next
EndProcedure

Macro DoubleQuote
    "
EndMacro

Macro Assert(Expression)
    CompilerIf #PB_Compiler_Debugger
    If (Not (Expression))
        Debug "Assert (Line " + #PB_Compiler_Line + "): " + DoubleQuote#Expression#DoubleQuote
        RaiseError(#PB_OnError_Breakpoint)
    EndIf
    CompilerEndIf
EndMacro

;*****************
;- Structures
;*****************


; IDE Options = PureBasic 5.11 (Windows - x64)
; CursorPosition = 44
; FirstLine = 4
; Folding = -
; EnableAsm
; EnableUnicode
; EnableThread
; EnableXP
; CPU = 1